using System;
using System.Security ;
using System.Security.Principal  ;
using System.Collections ;
using System.Xml;
using System.Reflection;
using System.IO;
using System.Threading;

namespace CSTSecurity
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class AuthenticationModule
	{
		public AuthenticationModule()
		{
		}
		public static void Login() {
			MycustomPrincipal l_MycustomPrincipal = new  
				MycustomPrincipal (WindowsIdentity.GetCurrent());
			Thread.CurrentPrincipal = l_MycustomPrincipal ;
			AppDomain.CurrentDomain.SetThreadPrincipal(l_MycustomPrincipal);
		}
		public class MycustomPrincipal : IPrincipal		{
			private static XmlDocument  i_xmlroles= new XmlDocument ();
			private IIdentity i_Identity =null;
			private ArrayList i_roles=new ArrayList() ;

			static MycustomPrincipal() 
			{
				i_xmlroles.Load (Path.GetDirectoryName (Assembly.GetExecutingAssembly().Location)  + @"\Roles.xml" );
			}

			//code outside this assembly can't create this principal object
			internal MycustomPrincipal(IIdentity p_IIdentity) {
				lock (i_xmlroles) {
					XmlNodeList l_roles =  i_xmlroles.SelectNodes ("//role[user/@name='" + p_IIdentity.Name  + "']");
					foreach (XmlNode l_rl in l_roles ) 
						i_roles.Add (l_rl.Attributes.GetNamedItem ("name").Value );						
				}
			}
			public IIdentity Identity
			{
				get {
					return i_Identity;
				}
			}

			public bool IsInRole(string role)
			{
				return i_roles.Contains (role);
			}
		}
	}
}
